// SPI flash benchmark

#ifndef FSIM_BENCH_H
#define FSIM_BENCH_H

#include <stdint.h>

struct bench;

/** benchmark alloc & init */
struct bench * bench_init(uint32_t block_count);

/** one time benchmark init */
void bench_free(struct bench * bench);

/** reset all counters */
void bench_clear(struct bench *bench);

/** Get current IO time (ns) */
uint64_t bench_get_io_time(struct bench *bench);

/** add IO time (called from the flash simulation code) */
void bench_add_io_time(struct bench *bench, uint64_t ns);

/** add block erase count (called from the flash simulation code) */
void bench_block_erased(struct bench *bench, uint32_t num);

/** add block write count */
void bench_block_written(struct bench * bench, uint32_t num);

/** print benchmarking stats and show erase cycle counters */
void bench_show_stats(struct bench *bench, bool colors);

#endif /* FSIM_BENCH_H */
